option strict off
imports System
imports System.Threading
imports System.Reflection
imports jabber.client
imports jabber.protocol.client
imports Excel

class MainClass  
	public shared sub Main()
		dim app as MainClass
		app = new MainClass()
	end sub

	private jabber as JabberClient
	private excel as Application
	private sheet as _Worksheet
	private sumCell as Range
	private currentRow = 1
	private die as new ManualResetEvent(false)

	private sub UpdatePresence(val as double) 
		jabber.Presence(PresenceType.available, _
		       String.Format("Sum={0}",val), "Available", 0)
	end sub
	private sub newMessage(sender as object, msg as Message) 
		if (msg.Body.Equals("Quit")) then
			die.Set()
			return
		end if
		dim dValue as double
		dvalue = 0.0
		try 
			dValue = Double.Parse(msg.Body)
		catch ex as Exception 
			Console.WriteLine(ex.StackTrace)
			return
		end try
		dim value as double
		value = UpdateExcel(msg.From.ToString(), dValue)
		UpdatePresence(value)
	end sub
	private connected = false
	private sub newIQ(sender as object, iq as IQ)
		if ((not connected) and jabber.IsAuthenticated) then
 		  connected = true
		  UpdatePresence(0.0)
		end if
	end sub
	private sub newPresence(sender as object, pres as Presence) 
		if (pres.Type.Equals(PresenceType.subscribe)) then
		  dim response as Presence
		  response = new Presence(jabber.Document)
		  response.Type = PresenceType.subscribed
		  response.To = pres.From
		  jabber.Write(response)
		end if
	end sub
	private function InitializeExcel() as Application
		dim app as new Application()
		app.Visible = true
		app.DisplayAlerts = false
		dim workbooks as Workbooks
		workbooks = app.Workbooks
		dim workbook as _Workbook 
		workbook = workbooks.Add( XlWBATemplate.xlWBATWorksheet)
		dim sheets as Sheets
		sheets = workbook.Worksheets
		sheet = sheets.Item(1)
		sumCell = sheet.Range("C1", Missing.Value)
		sumCell.Formula = "=SUM(B:B)"
		return app
	end function

	private function UpdateExcel(who as String, value as double) as double
		dim range as Range 
		range = sheet.Range(String.Format("A{0}",currentRow), _
		        String.Format("B{0}",currentRow))
		dim aRow(2) as object
		aRow(0) = who
		aRow(1) = value
		range.Value2 = aRow
		currentRow = currentRow + 1
		return sumCell.Value2
	end function
	private function InitializeJabber() as JabberClient
		dim c as new JabberClient()
		c.Server = "my-jabber"
		c.User = "excel"
		c.Password = "excel"
		c.Resource = "Work"
		c.AutoLogin = true
		c.Connect()
		AddHandler c.OnMessage, addressOf newMessage
		AddHandler c.OnIQ, addressof newIQ
		AddHandler c.OnPresence, addressof newPresence
		return c
	end function
	public sub New() 
		excel = InitializeExcel()
		jabber = InitializeJabber()
		die.WaitOne()
		jabber.Close()
		excel.Quit()
	end sub
end class
